# MiKTeX

The [MiKTeX Project Page](https://miktex.org) is the place to go, if
you are new to MiKTeX. In short:

- MiKTeX is both a modern C/C++ implementation of TeX & Friends and a
  TeX distribution.

- MiKTeX is a scalable TeX distribution (["Just enough
  TeX"](https://miktex.org/kb/just-enough-tex)):
  * you can start with MiKTeX executables and man pages
  * in the course of authoring your documents: only necessary packages
    will be downloaded and installed

The MiKTeX source code is documented here:
https://docs.miktex.org/hacking/index.html

MiKTeX can be built on Windows and Unix-like (including macOS)
systems.  Please consult these HOWTOs for platform-specific build
instructions:

* [https://miktex.org/howto/build-win](https://miktex.org/howto/build-win "Building MiKTeX (Windows)")
* [https://miktex.org/howto/build-unx](https://miktex.org/howto/build-unx "Building MiKTeX (Unix-like)")
* [https://miktex.org/howto/build-mac](https://miktex.org/howto/build-mac "Building MiKTeX (macOS)")

In addition, you can try one of the Dockerized build environments to build MiKTeX:

* [Ubuntu 16.04, 18.04](https://github.com/MiKTeX/docker-miktex-build-ubuntu)
* [Debian 9](https://github.com/MiKTeX/docker-miktex-build-debian)
* [Fedora 28, 30](https://github.com/MiKTeX/docker-miktex-build-fedora)
* [openSUSE Leap 15](https://github.com/MiKTeX/docker-miktex-build-opensuse)
